Description

When I parsed a binary protocol (msgpack) by String#unpack, there are many similar expressions, like below:

str = io.read(1)

length = str.unpack('C').first

case length

when 4

  data = io.read(4).unpack('N').first

# ...

 I know that unpack returns "1 or more" values, but I think there are too many cases to return just one object.

Creating Array objects for return values requires additional cost to create Array object, and calling .first.

I'm happy if I can write the code above like this:

str = io.read(1)

length = str.unpack('C', 0) # index, or str.unpack('C', index: 0)

case length

when 4

  data = io.read(4).unpack('N', 0)

# ...

Associated revisions

Revision 306f43acfef7959a9a41a13ce627b2493eb8993e - 12/01/2016 02:18 PM - naruse (Yui NARUSE)

String#unpack1 [Feature #12752]

Returns the first value of String#unpack.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56959 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 306f43ac - 12/01/2016 02:18 PM - naruse (Yui NARUSE)

String#unpack1 [Feature #12752]

Returns the first value of String#unpack.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56959 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 09/12/2016 06:41 AM - shyouhei (Shyouhei Urabe)

- Description updated

#2 - 09/13/2016 03:51 PM - mame (Yusuke Endoh)

There is more concise way:

length, = str.unpack('C')

 You cannot use this in a method chain, though.

I actually understand your frustration, but I feel no difference between str.unpack('C', 0) and str.unpack('C')[0].

--

Yusuke Endoh mame@ruby-lang.org
#3 - 11/25/2016 07:39 AM - naruse (Yui NARUSE)

How about Array#unpack1 ?

#4 - 11/25/2016 07:42 AM - matz (Yukihiro Matsumoto)

unpack1 looks so ad-hoc but surely is attractive.

Matz.

#5 - 12/01/2016 09:52 AM - matz (Yukihiro Matsumoto)

Go ahead.

Matz.

#6 - 12/01/2016 10:25 AM - knu (Akinori MUSHA)

With a qualifier or multiple directives given, would it raise an ArgumentError or just go ahead with the process and only return the first value?

#7 - 12/01/2016 01:49 PM - naruse (Yui NARUSE)

Akinori MUSHA wrote:

With a qualifier or multiple directives given, would it raise an ArgumentError or just go ahead with the process and only return the first value?

 Just after processing the first value, it returns.

#8 - 12/01/2016 02:18 PM - naruse (Yui NARUSE)

- Status changed from Open to Closed

Applied in changeset r56959.

String#unpack1 [Feature #12752]

Returns the first value of String#unpack.

Powered by TCPDF (www.tcpdf.org)

10/30/2025 2/2

https://bugs.ruby-lang.org/issues/12752
http://www.tcpdf.org

